include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "logic.ma".
include "nat.ma".
include "relations.ma".
definition injn : (nat -> nat) -> nat -> Prop := \lambda f : nat -> nat. \lambda n : nat. \forall (i:nat). \forall (j:nat). ((le)  i n) -> ((le)  j n) -> ((eq) (nat) (f i) (f j)) -> (eq) (nat) i j.
definition permut : (nat -> nat) -> nat -> Prop := \lambda f : nat -> nat. \lambda m : nat. (And)  (\forall (i:nat). ((le)  i m) -> (le)  (f i) m) ((injn)  f m).
definition transpose : nat -> nat -> nat -> nat := \lambda i : nat. \lambda j : nat. \lambda n : nat. (match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) ((eqb)  n i).
definition transpose_i_j_i : \forall (i:nat). \forall (j:nat). (eq) (nat) ((transpose)  i j i) j := \lambda i : nat. \lambda j : nat. ((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i i ((eqb)  i j)) x) j)) ((((((eq_match_bool_type_true) (nat)) (j)) ((match_bool_type) (nat) i i ((eqb)  i j))) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i i ((eqb)  i j)) (true) ) y)) (((refl) (nat)) ((match_bool_type) (nat) j ((match_bool_type) (nat) i i ((eqb)  i j)) (true) )))) ((eqb)  i i)) ((eqb_n_n) (i)).
definition transpose_i_j_j : \forall (i:nat). \forall (j:nat). (eq) (nat) ((transpose)  i j j) i := \lambda i : nat. \lambda j : nat. ((((((match_Or_prop) ((eq) (bool) ((eqb)  j i) (true) )) ((eq) (bool) ((eqb)  j i) (false) )) ((eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i j ((eqb)  j j)) ((eqb)  j i)) i)) (\lambda Hc : (eq) (bool) ((eqb)  j i) (true) . (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i j ((eqb)  j j)) x) i)) ((((((sym_eq_match_bool_type_true) (nat)) (j)) ((match_bool_type) (nat) i j ((eqb)  j j))) (\lambda y : nat. (eq) (nat) y i)) (((((((eq_ind_r) (nat)) (i)) (\lambda x : nat. (eq) (nat) x i)) (((refl) (nat)) (i))) (j)) ((((eqb_true_to_eq) (j)) (i)) (Hc))))) ((eqb)  j i)) (Hc)))) (\lambda Hc : (eq) (bool) ((eqb)  j i) (false) . (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i j ((eqb)  j j)) x) i)) (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i j x) (false) ) i)) ((((((sym_eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i j (true) )) (\lambda y : nat. (eq) (nat) y i)) ((((((eq_match_bool_type_true) (nat)) (i)) (j)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) i j (true) ) y)) ((((((eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i j (true) )) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) i j (true) ) y)) ((((((eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i j (true) )) (\lambda y : nat. (eq) (nat) y ((match_bool_type) (nat) j ((match_bool_type) (nat) i j (true) ) (false) ))) (((refl) (nat)) ((match_bool_type) (nat) j ((match_bool_type) (nat) i j (true) ) (false) ))))))) ((eqb)  j j)) ((eqb_n_n) (j)))) ((eqb)  j i)) (Hc)))) ((true_or_false) ((eqb)  j i)).
definition transpose_transpose : \forall (i:nat). \forall (j:nat). \forall (n:nat). (eq) (nat) ((transpose)  i j ((transpose)  i j n)) n := \lambda i : nat. \lambda j : nat. \lambda n : nat. ((((((match_Or_prop) ((eq) (bool) ((eqb)  n i) (true) )) ((eq) (bool) ((eqb)  n i) (false) )) ((eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) ((eqb)  n i)) ((eqb)  ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) ((eqb)  n i)) j)) ((eqb)  ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) ((eqb)  n i)) i)) n)) (\lambda Hni : (eq) (bool) ((eqb)  n i) (true) . (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) x) ((eqb)  ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) x) j)) ((eqb)  ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) x) i)) n)) ((((((sym_eq_match_bool_type_true) (nat)) (j)) ((match_bool_type) (nat) i n ((eqb)  n j))) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) (true) ) ((eqb)  ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) (true) ) j)) ((eqb)  y i)) n)) ((((((sym_eq_match_bool_type_true) (nat)) (j)) ((match_bool_type) (nat) i n ((eqb)  n j))) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) (true) ) ((eqb)  y j)) ((eqb)  j i)) n)) ((((((sym_eq_match_bool_type_true) (nat)) (j)) ((match_bool_type) (nat) i n ((eqb)  n j))) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i y ((eqb)  j j)) ((eqb)  j i)) n)) (((((((match_Or_prop) ((eq) (bool) ((eqb)  j i) (true) )) ((eq) (bool) ((eqb)  j i) (false) )) ((eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i j ((eqb)  j j)) ((eqb)  j i)) n)) (\lambda Hji : (eq) (bool) ((eqb)  j i) (true) . (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i j ((eqb)  j j)) x) n)) ((((((sym_eq_match_bool_type_true) (nat)) (j)) ((match_bool_type) (nat) i j ((eqb)  j j))) (\lambda y : nat. (eq) (nat) y n)) (((((((eq_ind_r) (nat)) (i)) (\lambda x : nat. (eq) (nat) j x)) ((((eqb_true_to_eq) (j)) (i)) (Hji))) (n)) ((((eqb_true_to_eq) (n)) (i)) (Hni))))) ((eqb)  j i)) (Hji)))) (\lambda Hji : (eq) (bool) ((eqb)  j i) (false) . (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i j ((eqb)  j j)) x) n)) ((((((sym_eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i j ((eqb)  j j))) (\lambda y : nat. (eq) (nat) y n)) (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) i j x) n)) ((((((sym_eq_match_bool_type_true) (nat)) (i)) (j)) (\lambda y : nat. (eq) (nat) y n)) (((((sym_eq) (nat)) (n)) (i)) ((((eqb_true_to_eq) (n)) (i)) (Hni))))) ((eqb)  j j)) ((eqb_n_n) (j))))) ((eqb)  j i)) (Hji)))) ((true_or_false) ((eqb)  j i))))))) ((eqb)  n i)) (Hni)))) (\lambda Hni : (eq) (bool) ((eqb)  n i) (false) . (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) x) ((eqb)  ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) x) j)) ((eqb)  ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) x) i)) n)) ((((((sym_eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i n ((eqb)  n j))) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) (false) ) ((eqb)  ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) (false) ) j)) ((eqb)  y i)) n)) ((((((sym_eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i n ((eqb)  n j))) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) (false) ) ((eqb)  y j)) ((eqb)  ((match_bool_type) (nat) i n ((eqb)  n j)) i)) n)) ((((((sym_eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i n ((eqb)  n j))) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i y ((eqb)  ((match_bool_type) (nat) i n ((eqb)  n j)) j)) ((eqb)  ((match_bool_type) (nat) i n ((eqb)  n j)) i)) n)) (((((((match_Or_prop) ((eq) (bool) ((eqb)  n j) (true) )) ((eq) (bool) ((eqb)  n j) (false) )) ((eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) i n ((eqb)  n j)) ((eqb)  ((match_bool_type) (nat) i n ((eqb)  n j)) j)) ((eqb)  ((match_bool_type) (nat) i n ((eqb)  n j)) i)) n)) (\lambda Hnj : (eq) (bool) ((eqb)  n j) (true) . (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) i n x) ((eqb)  ((match_bool_type) (nat) i n x) j)) ((eqb)  ((match_bool_type) (nat) i n x) i)) n)) ((((((sym_eq_match_bool_type_true) (nat)) (i)) (n)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) i n (true) ) ((eqb)  ((match_bool_type) (nat) i n (true) ) j)) ((eqb)  y i)) n)) ((((((sym_eq_match_bool_type_true) (nat)) (i)) (n)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) i n (true) ) ((eqb)  y j)) ((eqb)  i i)) n)) ((((((sym_eq_match_bool_type_true) (nat)) (i)) (n)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i y ((eqb)  i j)) ((eqb)  i i)) n)) (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i i ((eqb)  i j)) x) n)) ((((((sym_eq_match_bool_type_true) (nat)) (j)) ((match_bool_type) (nat) i i ((eqb)  i j))) (\lambda y : nat. (eq) (nat) y n)) (((((sym_eq) (nat)) (n)) (j)) ((((eqb_true_to_eq) (n)) (j)) (Hnj))))) ((eqb)  i i)) ((eqb_n_n) (i))))))) ((eqb)  n j)) (Hnj)))) (\lambda Hnj : (eq) (bool) ((eqb)  n j) (false) . (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) i n x) ((eqb)  ((match_bool_type) (nat) i n x) j)) ((eqb)  ((match_bool_type) (nat) i n x) i)) n)) ((((((sym_eq_match_bool_type_false) (nat)) (i)) (n)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) i n (false) ) ((eqb)  ((match_bool_type) (nat) i n (false) ) j)) ((eqb)  y i)) n)) ((((((sym_eq_match_bool_type_false) (nat)) (i)) (n)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i ((match_bool_type) (nat) i n (false) ) ((eqb)  y j)) ((eqb)  n i)) n)) ((((((sym_eq_match_bool_type_false) (nat)) (i)) (n)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i y ((eqb)  n j)) ((eqb)  n i)) n)) (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i n ((eqb)  n j)) x) n)) (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i n x) (false) ) n)) ((((((eq_match_bool_type_false) (nat)) (i)) (n)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i n (false) ) (false) ) y)) ((((((eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i n (false) )) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i n (false) ) (false) ) y)) (((refl) (nat)) ((match_bool_type) (nat) j ((match_bool_type) (nat) i n (false) ) (false) ))))) ((eqb)  n j)) (Hnj))) ((eqb)  n i)) (Hni)))))) ((eqb)  n j)) (Hnj)))) ((true_or_false) ((eqb)  n j))))))) ((eqb)  n i)) (Hni)))) ((true_or_false) ((eqb)  n i)).
definition injective_transpose : \forall (i:nat). \forall (j:nat). (injective) (nat) (nat) ((transpose)  i j) := \lambda i : nat. \lambda j : nat. \lambda x : nat. \lambda y : nat. \lambda auto : (eq) (nat) ((transpose)  i j x) ((transpose)  i j y). (((((((rewrite_r) (nat)) (y)) (\lambda j__ : nat. (eq) (nat) j__ y)) (((refl) (nat)) (y))) (x)) (((((((rewrite_l) (nat)) ((transpose)  i j ((transpose)  i j x))) (\lambda j__ : nat. (eq) (nat) j__ y)) (((((((rewrite_r) (nat)) ((transpose)  i j y)) (\lambda j__ : nat. (eq) (nat) ((transpose)  i j j__) y)) ((((transpose_transpose) (i)) (j)) (y))) ((transpose)  i j x)) (auto))) (x)) ((((transpose_transpose) (i)) (j)) (x)))).
definition permut_S_to_permut_transpose : \forall (f:nat -> nat). \forall (m:nat). ((permut)  f ((S)  m)) -> (permut)  (\lambda n : nat. (transpose)  (f ((S)  m)) ((S)  m) (f n)) m := \lambda f : nat -> nat. \lambda m : nat. \lambda j_clearme : (permut)  f ((S)  m). ((((((match_And_prop) (\forall (i:nat). ((le)  i ((S)  m)) -> (le)  (f i) ((S)  m))) ((injn)  f ((S)  m))) ((permut)  (\lambda n : nat. (transpose)  (f ((S)  m)) ((S)  m) (f n)) m)) (\lambda permf1 : \forall (i:nat). ((le)  i ((S)  m)) -> (le)  (f i) ((S)  m). (\lambda permf2 : (injn)  f ((S)  m). (((((conj) (\forall (x:nat). ((le)  x m) -> (le)  ((transpose)  (f ((S)  m)) ((S)  m) (f x)) m)) ((injn)  (\lambda n : nat. (transpose)  (f ((S)  m)) ((S)  m) (f n)) m)) (\lambda i : nat. \lambda leim : (le)  i m. (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (le)  ((match_bool_type) (nat) ((S)  m) ((match_bool_type) (nat) (f ((S)  m)) (f i) ((eqb)  (f i) ((S)  m))) x) m)) ((((((sym_eq_match_bool_type_false) (nat)) ((S)  m)) ((match_bool_type) (nat) (f ((S)  m)) (f i) ((eqb)  (f i) ((S)  m)))) (\lambda y : nat. (le)  y m)) (((((((match_Or_prop) ((lt)  (f i) ((S)  m))) ((eq) (nat) (f i) ((S)  m))) ((le)  ((match_bool_type) (nat) (f ((S)  m)) (f i) ((eqb)  (f i) ((S)  m))) m)) (\lambda Hfi : (lt)  (f i) ((S)  m). (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (le)  ((match_bool_type) (nat) (f ((S)  m)) (f i) x) m)) ((((((sym_eq_match_bool_type_false) (nat)) (f ((S)  m))) (f i)) (\lambda y : nat. (le)  y m)) ((((le_S_S_to_le) (f i)) (m)) (Hfi)))) ((eqb)  (f i) ((S)  m))) ((((not_eq_to_eqb_false) (f i)) ((S)  m)) ((((lt_to_not_eq) (f i)) ((S)  m)) (Hfi)))))) (\lambda Hfi : (eq) (nat) (f i) ((S)  m). (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (le)  ((match_bool_type) (nat) (f ((S)  m)) (f i) x) m)) ((((((sym_eq_match_bool_type_true) (nat)) (f ((S)  m))) (f i)) (\lambda y : nat. (le)  y m)) (((((((match_Or_prop) ((lt)  (f ((S)  m)) ((S)  m))) ((eq) (nat) (f ((S)  m)) ((S)  m))) ((le)  (f ((S)  m)) m)) (\lambda H : (lt)  (f ((S)  m)) ((S)  m). ((((le_S_S_to_le) (f ((S)  m))) (m)) (H)))) (\lambda H : (eq) (nat) (f ((S)  m)) ((S)  m). (((falsity) ((le)  (f ((S)  m)) m)) ((((absurd) ((eq) (nat) i ((S)  m))) ((((((permf2) (i)) ((S)  m)) ((((le_S) (i)) (m)) (leim))) ((le_n) ((S)  m))) (((((((rewrite_l) (nat)) (f i)) (\lambda j__ : nat. (eq) (nat) (f i) (f j__))) (((((((rewrite_r) (nat)) (f i)) (\lambda j__ : nat. (eq) (nat) (f i) j__)) (((refl) (nat)) (f i))) (f (f i))) (((((((rewrite_r) (nat)) ((S)  m)) (\lambda j__ : nat. (eq) (nat) (f (f i)) j__)) (((((((rewrite_r) (nat)) ((S)  m)) (\lambda j__ : nat. (eq) (nat) (f j__) ((S)  m))) (H)) (f i)) (Hfi))) (f i)) (Hfi)))) ((S)  m)) (Hfi)))) (((((not_to_not) ((eq) (nat) i ((S)  m))) ((le)  ((S)  m) m)) (\lambda auto : (eq) (nat) i ((S)  m). (((((eq_coerc) ((le)  i m)) ((le)  ((S)  m) m)) (leim)) (((((((rewrite_l) (nat)) (i)) (\lambda j__ : nat. (eq) (Prop) ((le)  i m) ((le)  j__ m))) (((refl) (Prop)) ((le)  i m))) ((S)  m)) (auto))))) ((((lt_to_not_le) (m)) ((S)  m)) ((le_n) ((S)  m)))))))) ((((le_to_or_lt_eq) (f ((S)  m))) ((S)  m)) (((permf1) ((S)  m)) ((le_n) ((S)  m))))))) ((eqb)  (f i) ((S)  m))) ((((eq_to_eqb_true) (f i)) ((S)  m)) (Hfi))))) ((((le_to_or_lt_eq) (f i)) ((S)  m)) (((permf1) (i)) ((((le_S) (i)) (m)) (leim))))))) ((eqb)  (f i) (f ((S)  m)))) ((((not_eq_to_eqb_false) (f i)) (f ((S)  m))) (((nmk) ((eq) (nat) (f i) (f ((S)  m)))) (\lambda H : (eq) (nat) (f i) (f ((S)  m)). ((((absurd) ((eq) (nat) i ((S)  m))) ((((((permf2) (i)) ((S)  m)) ((((le_S) (i)) (m)) (leim))) ((le_n) ((S)  m))) (H))) ((((lt_to_not_eq) (i)) ((S)  m)) ((((le_S_S) (i)) (m)) (leim)))))))))) (\lambda a : nat. \lambda b : nat. \lambda leam : (le)  a m. (\lambda lebm : (le)  b m. (\lambda H : (eq) (nat) ((transpose)  (f ((S)  m)) ((S)  m) (f a)) ((transpose)  (f ((S)  m)) ((S)  m) (f b)). ((((((permf2) (a)) (b)) ((((le_S) (a)) (m)) (leam))) ((((le_S) (b)) (m)) (lebm))) ((((((injective_transpose) (f ((S)  m))) ((S)  m)) (f a)) (f b)) (H)))))))))) (j_clearme)).
definition bijn : (nat -> nat) -> nat -> Prop := \lambda f : nat -> nat. \lambda n : nat. \forall (m:nat). ((le)  m n) -> (ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (f p) m)).
definition eq_to_bijn : \forall (f:nat -> nat). \forall (g:nat -> nat). \forall (n:nat). (\forall (i:nat). ((le)  i n) -> (eq) (nat) (f i) (g i)) -> ((bijn)  f n) -> (bijn)  g n := \lambda f : nat -> nat. \lambda g : nat -> nat. \lambda n : nat. \lambda H : \forall (i:nat). ((le)  i n) -> (eq) (nat) (f i) (g i). (\lambda bijf : (bijn)  f n. (\lambda i : nat. \lambda lein : (le)  i n. ((((((match_ex_prop) (nat)) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (f p) i))) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (g p) i)))) (\lambda a : nat. \lambda j_clearme : (And)  ((le)  a n) ((eq) (nat) (f a) i). ((((((match_And_prop) ((le)  a n)) ((eq) (nat) (f a) i)) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (g p) i)))) (\lambda lean : (le)  a n. (\lambda fa : (eq) (nat) (f a) i. (((((ex_intro) (nat)) (\lambda x : nat. (And)  ((le)  x n) ((eq) (nat) (g x) i))) (a)) (((((conj) ((le)  a n)) ((eq) (nat) (g a) i)) (lean)) (((((((eq_ind) (nat)) (f a)) (\lambda x_1 : nat. (eq) (nat) (g a) x_1)) (((((sym_eq) (nat)) (f a)) (g a)) (((H) (a)) (lean)))) (i)) (fa))))))) (j_clearme)))) (((bijf) (i)) (lein))))).
definition bijn_n_Sn : \forall (f:nat -> nat). \forall (n:nat). ((bijn)  f n) -> ((eq) (nat) (f ((S)  n)) ((S)  n)) -> (bijn)  f ((S)  n) := \lambda f : nat -> nat. \lambda n : nat. \lambda bijf : (bijn)  f n. (\lambda fS : (eq) (nat) (f ((S)  n)) ((S)  n). (\lambda i : nat. \lambda lein : (le)  i ((S)  n). (((((((match_Or_prop) ((lt)  i ((S)  n))) ((eq) (nat) i ((S)  n))) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p ((S)  n)) ((eq) (nat) (f p) i)))) (\lambda Hi : (lt)  i ((S)  n). ((((((match_ex_prop) (nat)) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (f p) i))) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p ((S)  n)) ((eq) (nat) (f p) i)))) (\lambda a : nat. \lambda j_clearme : (And)  ((le)  a n) ((eq) (nat) (f a) i). ((((((match_And_prop) ((le)  a n)) ((eq) (nat) (f a) i)) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p ((S)  n)) ((eq) (nat) (f p) i)))) (\lambda lean : (le)  a n. (\lambda fa : (eq) (nat) (f a) i. (((((ex_intro) (nat)) (\lambda x : nat. (And)  ((le)  x ((S)  n)) ((eq) (nat) (f x) i))) (a)) (((((conj) ((le)  a ((S)  n))) ((eq) (nat) (f a) i)) ((((le_S) (a)) (n)) (lean))) (((((((rewrite_r) (nat)) (i)) (\lambda j__ : nat. (eq) (nat) j__ i)) (((refl) (nat)) (i))) (f a)) (fa))))))) (j_clearme)))) (((bijf) (i)) ((((le_S_S_to_le) (i)) (n)) (Hi)))))) (\lambda Hi : (eq) (nat) i ((S)  n). (((((ex_intro) (nat)) (\lambda x : nat. (And)  ((le)  x ((S)  n)) ((eq) (nat) (f x) i))) (i)) (((((conj) ((le)  i ((S)  n))) ((eq) (nat) (f i) i)) (((((eq_coerc) ((le)  i i)) ((le)  i ((S)  n))) ((le_n) (i))) (((((((rewrite_l) (nat)) (i)) (\lambda j__ : nat. (eq) (Prop) ((le)  i i) ((le)  i j__))) (((refl) (Prop)) ((le)  i i))) ((S)  n)) (Hi)))) (((((((rewrite_r) (nat)) (i)) (\lambda j__ : nat. (eq) (nat) j__ i)) (((refl) (nat)) (i))) (f i)) (((((((rewrite_r) (nat)) ((S)  n)) (\lambda j__ : nat. (eq) (nat) (f i) j__)) (((((((rewrite_r) (nat)) ((S)  n)) (\lambda j__ : nat. (eq) (nat) (f j__) ((S)  n))) (fS)) (i)) (Hi))) (i)) (Hi))))))) ((((le_to_or_lt_eq) (i)) ((S)  n)) (lein))))).
definition bijn_fg : \forall (f:nat -> nat). \forall (g:nat -> nat). \forall (n:nat). ((bijn)  f n) -> ((bijn)  g n) -> (bijn)  (\lambda p : nat. f (g p)) n := \lambda f : nat -> nat. \lambda g : nat -> nat. \lambda n : nat. \lambda bijf : (bijn)  f n. (\lambda bijg : (bijn)  g n. (\lambda i : nat. \lambda lein : (le)  i n. ((((((match_ex_prop) (nat)) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (f p) i))) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (f (g p)) i)))) (\lambda a : nat. \lambda j_clearme : (And)  ((le)  a n) ((eq) (nat) (f a) i). ((((((match_And_prop) ((le)  a n)) ((eq) (nat) (f a) i)) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (f (g p)) i)))) (\lambda lean : (le)  a n. (\lambda ga : (eq) (nat) (f a) i. ((((((match_ex_prop) (nat)) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (g p) a))) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (f (g p)) i)))) (\lambda b : nat. \lambda j_clearme0 : (And)  ((le)  b n) ((eq) (nat) (g b) a). ((((((match_And_prop) ((le)  b n)) ((eq) (nat) (g b) a)) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) (f (g p)) i)))) (\lambda lebn : (le)  b n. (\lambda gb : (eq) (nat) (g b) a. (((((ex_intro) (nat)) (\lambda x : nat. (And)  ((le)  x n) ((eq) (nat) (f (g x)) i))) (b)) (((((conj) ((le)  b n)) ((eq) (nat) (f (g b)) i)) (lebn)) (((((((rewrite_r) (nat)) (a)) (\lambda j__ : nat. (eq) (nat) (f j__) i)) (((((((rewrite_r) (nat)) (i)) (\lambda j__ : nat. (eq) (nat) j__ i)) (((refl) (nat)) (i))) (f a)) (ga))) (g b)) (gb))))))) (j_clearme0)))) (((bijg) (a)) (lean)))))) (j_clearme)))) (((bijf) (i)) (lein))))).
definition bijn_transpose : \forall (n:nat). \forall (i:nat). \forall (j:nat). ((le)  i n) -> ((le)  j n) -> (bijn)  ((transpose)  i j) n := \lambda n : nat. \lambda i : nat. \lambda j : nat. \lambda lein : (le)  i n. (\lambda lejn : (le)  j n. (\lambda a : nat. \lambda lean : (le)  a n. (((((((match_Or_prop) ((eq) (bool) ((eqb)  a i) (true) )) ((eq) (bool) ((eqb)  a i) (false) )) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) ((transpose)  i j p) a)))) (\lambda Hi : (eq) (bool) ((eqb)  a i) (true) . (((((ex_intro) (nat)) (\lambda x : nat. (And)  ((le)  x n) ((eq) (nat) ((transpose)  i j x) a))) (j)) (((((conj) ((le)  j n)) ((eq) (nat) ((transpose)  i j j) a)) (lejn)) (((((((eq_ind_r) (nat)) (i)) (\lambda x : nat. (eq) (nat) x a)) (((((sym_eq) (nat)) (a)) (i)) ((((eqb_true_to_eq) (a)) (i)) (Hi)))) ((transpose)  i j j)) (((transpose_i_j_j) (i)) (j))))))) (\lambda Hi : (eq) (bool) ((eqb)  a i) (false) . (((((((match_Or_prop) ((eq) (bool) ((eqb)  a j) (true) )) ((eq) (bool) ((eqb)  a j) (false) )) ((ex) (nat) (\lambda p : nat. (And)  ((le)  p n) ((eq) (nat) ((transpose)  i j p) a)))) (\lambda Hj : (eq) (bool) ((eqb)  a j) (true) . (((((ex_intro) (nat)) (\lambda x : nat. (And)  ((le)  x n) ((eq) (nat) ((transpose)  i j x) a))) (i)) (((((conj) ((le)  i n)) ((eq) (nat) ((transpose)  i j i) a)) (lein)) (((((((eq_ind_r) (nat)) (j)) (\lambda x : nat. (eq) (nat) x a)) (((((sym_eq) (nat)) (a)) (j)) ((((eqb_true_to_eq) (a)) (j)) (Hj)))) ((transpose)  i j i)) (((transpose_i_j_i) (i)) (j))))))) (\lambda Hj : (eq) (bool) ((eqb)  a j) (false) . (((((ex_intro) (nat)) (\lambda x : nat. (And)  ((le)  x n) ((eq) (nat) ((transpose)  i j x) a))) (a)) (((((conj) ((le)  a n)) ((eq) (nat) ((transpose)  i j a) a)) (lean)) (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i a ((eqb)  a j)) x) a)) (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i a x) (false) ) a)) ((((((eq_match_bool_type_false) (nat)) (i)) (a)) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i a (false) ) (false) ) y)) ((((((eq_match_bool_type_false) (nat)) (j)) ((match_bool_type) (nat) i a (false) )) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) j ((match_bool_type) (nat) i a (false) ) (false) ) y)) (((refl) (nat)) ((match_bool_type) (nat) j ((match_bool_type) (nat) i a (false) ) (false) ))))) ((eqb)  a j)) (Hj))) ((eqb)  a i)) (Hi)))))) ((true_or_false) ((eqb)  a j))))) ((true_or_false) ((eqb)  a i))))).
definition permut_to_bijn : \forall (n:nat). \forall (f:nat -> nat). ((permut)  f n) -> (bijn)  f n := \lambda n : nat. ((((nat_ind) (\lambda j_x_365 : nat. \forall (f:nat -> nat). ((permut)  f j_x_365) -> (bijn)  f j_x_365)) (\lambda f : nat -> nat. \lambda j_clearme : (And)  (\forall (i:nat). ((le)  i (O) ) -> (le)  (f i) (O) ) (\forall (i:nat). \forall (j:nat). ((le)  i (O) ) -> ((le)  j (O) ) -> ((eq) (nat) (f i) (f j)) -> (eq) (nat) i j). ((((((match_And_prop) (\forall (i:nat). ((le)  i (O) ) -> (le)  (f i) (O) )) (\forall (i:nat). \forall (j:nat). ((le)  i (O) ) -> ((le)  j (O) ) -> ((eq) (nat) (f i) (f j)) -> (eq) (nat) i j)) (\forall (m:nat). ((le)  m (O) ) -> (ex) (nat) (\lambda p : nat. (And)  ((le)  p (O) ) ((eq) (nat) (f p) m)))) (\lambda H : \forall (i:nat). ((le)  i (O) ) -> (le)  (f i) (O) . (\lambda H1 : \forall (i:nat). \forall (j:nat). ((le)  i (O) ) -> ((le)  j (O) ) -> ((eq) (nat) (f i) (f j)) -> (eq) (nat) i j. (\lambda m : nat. \lambda lem0 : (le)  m (O) . (((((ex_intro) (nat)) (\lambda x : nat. (And)  ((le)  x (O) ) ((eq) (nat) (f x) m))) ((O) )) (((((conj) ((le)  (O)  (O) )) ((eq) (nat) (f (O) ) m)) ((le_O_n) ((O) ))) (((((le_n_O_elim) (m)) (lem0)) ((eq) (nat) (f (O) ))) (((((sym_eq) (nat)) ((O) )) (f (O) )) (((le_n_O_to_eq) (f (O) )) (((H) ((O) )) ((le_O_n) ((O) )))))))))))) (j_clearme)))) (\lambda m : nat. \lambda Hind : \forall (f:nat -> nat). ((permut)  f m) -> (bijn)  f m. (\lambda f : nat -> nat. \lambda permf : (permut)  f ((S)  m). ((((((eq_to_bijn) (\lambda p : nat. (transpose)  (f ((S)  m)) ((S)  m) ((transpose)  (f ((S)  m)) ((S)  m) (f p)))) (f)) ((S)  m)) (\lambda i : nat. \lambda lei : (le)  i ((S)  m). ((((transpose_transpose) (f ((S)  m))) ((S)  m)) (f i)))) ((((((bijn_fg) ((transpose)  (f ((S)  m)) ((S)  m))) (\lambda j__ : nat. (transpose)  (f ((S)  m)) ((S)  m) (f j__))) ((S)  m)) ((((((match_And_prop) (\forall (i:nat). ((le)  i ((S)  m)) -> (le)  (f i) ((S)  m))) ((injn)  f ((S)  m))) ((bijn)  ((transpose)  (f ((S)  m)) ((S)  m)) ((S)  m))) (\lambda lef : \forall (i:nat). ((le)  i ((S)  m)) -> (le)  (f i) ((S)  m). (\lambda j__ : (injn)  f ((S)  m). ((((((bijn_transpose) ((S)  m)) (f ((S)  m))) ((S)  m)) (((lef) ((S)  m)) ((le_n) ((S)  m)))) ((le_n) ((S)  m)))))) (permf))) (((((bijn_n_Sn) (\lambda j__ : nat. (transpose)  (f ((S)  m)) ((S)  m) (f j__))) (m)) (((Hind) (\lambda j__ : nat. (transpose)  (f ((S)  m)) ((S)  m) (f j__))) ((((permut_S_to_permut_transpose) (f)) (m)) (permf)))) (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (nat) ((match_bool_type) (nat) ((S)  m) ((match_bool_type) (nat) (f ((S)  m)) (f ((S)  m)) ((eqb)  (f ((S)  m)) ((S)  m))) x) ((S)  m))) ((((((eq_match_bool_type_true) (nat)) ((S)  m)) ((match_bool_type) (nat) (f ((S)  m)) (f ((S)  m)) ((eqb)  (f ((S)  m)) ((S)  m)))) (\lambda y : nat. (eq) (nat) ((match_bool_type) (nat) ((S)  m) ((match_bool_type) (nat) (f ((S)  m)) (f ((S)  m)) ((eqb)  (f ((S)  m)) ((S)  m))) (true) ) y)) (((refl) (nat)) ((match_bool_type) (nat) ((S)  m) ((match_bool_type) (nat) (f ((S)  m)) (f ((S)  m)) ((eqb)  (f ((S)  m)) ((S)  m))) (true) )))) ((eqb)  (f ((S)  m)) (f ((S)  m)))) ((eqb_n_n) (f ((S)  m)))))))))) (n).
